//----------------------------------------------------------------------------
// SDcard access sample program
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "sd.h"

#ifndef CODESIZECHECK
#include "i2c_lcd.h"

//
//	Main
//
void main(void)
{
	signed char rc;
	int i;
	int fd;
	char fname[10] = "test.txt";
	char dname[10] = ".";
	static char buf[100] = "01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567\r";
	buf[99] = '\n';

//	SD_DIR	*dp;
//	struct sd_dirent *de;
//	struct sd_dirent dir;
//
//	dp = sd_opendir(dname);
//	while((de = sd_readdir(dp)) != 0) {
//		i2c_lcd_position(0,0);	i2c_lcd_prString(de->Name);
//	}
//	while(sd_readdir_r(dp, &dir, &de) == 0) {
//		i2c_lcd_position(0,0);	i2c_lcd_prString(dir.Name);
//	}
//	rc = sd_closedir(dp);
		
	M8C_EnableGInt;
	i2c_lcd_start();
	i2c_lcd_init();
	i2c_lcd_position(0,0);	i2c_lcd_prCString("Start...");
	
	// Mount
	if (sd_mount(0) < 0) {
		if (sd_errno == SD_EPERM) {
			i2c_lcd_position(1,0);	i2c_lcd_prCString("NOT INSERT");
		} else if (sd_errno == SD_ENXIO) {
			i2c_lcd_position(1,0);	i2c_lcd_prCString("NOT FORMAT");
		} else if (sd_errno == SD_ENODEV) {
			i2c_lcd_position(1,0);	i2c_lcd_prCString("FAT error");
		} else {
			i2c_lcd_position(1,0);	i2c_lcd_prCString("mount error");
		}
		for(;;);
	}

	// Open
	if ((fd = sd_open(fname, SD_O_CREAT|SD_O_APPEND, 0)) < 0) {
		i2c_lcd_position(1,0);	i2c_lcd_prCString("open error");
		for(;;);
	}

	// Write
	for(i = 0; i < 100; i++) {
		i2c_lcd_position(0,0);	i2c_lcd_prCString("write "); i2c_lcd_prHexInt(i);
		if ((rc = sd_write(fd, buf, sizeof(buf))) <= 0) {
			i2c_lcd_position(1,0);	i2c_lcd_prCString("write error "); i2c_lcd_prHexInt(i);
			for(;;);
		}
		if ((i % 10) == 0) {
			rc = sd_sync(fd);
		}
	}

	// Rewind
//	if (sd_lseek(fd, 0, SD_SEEK_SET) < 0) {
//		i2c_lcd_position(1,0);	i2c_lcd_prCString("lseek errord ");
//		for(;;);
//	}

	// Read
//	for(i = 0; i < 10; i++) {
//		i2c_lcd_position(0,0);	i2c_lcd_prCString("read ");i2c_lcd_prHexInt(i);
//		if ((rc = sd_read(fd, buf, sizeof(buf))) <= 0) {
//			i2c_lcd_position(1,0);	i2c_lcd_prCString("read error ");i2c_lcd_prHexInt(i);
//			for(;;);
//		}
//	}

	// Close
	rc = sd_close(fd);
	if (rc < 0) {
		i2c_lcd_position(1,0);	i2c_lcd_prCString("close error ");
		for(;;);
	}

	// unmount
	if (sd_unmount() < 0) {
		i2c_lcd_position(1,0);	i2c_lcd_prCString("unmount error ");
		for(;;);
	}

	// Mount2
	if (sd_mount(0) < 0) {
		i2c_lcd_position(1,0);	i2c_lcd_prCString("mount2 error ");
		for(;;);
	}
	
	// unmount2
	if (sd_unmount() < 0) {
		i2c_lcd_position(1,0);	i2c_lcd_prCString("unmount2 error ");
		for(;;);
	}

	i2c_lcd_position(1,0);	i2c_lcd_prCString("End...........");
}

#else // CODESIZECHECK

void main(void)
{
	signed char rc;
	int i;
	int fd;
	char fname[10] = "test.txt";
	char buf[100] = "01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567\r\n";

	rc = sd_mount(0);
	fd = sd_open(fname, SD_O_CREAT|SD_O_APPEND, 0);
	rc = sd_write(fd, buf, sizeof(buf));
	sd_lseek(fd, 0, SD_SEEK_SET);
	rc = sd_read(fd, buf, sizeof(buf));
	rc = sd_close(fd);
	sd_unmount();
}
#endif